config/routes.rb
Rails.application.routes.draw do
  get 'welcome/index'
  get 'home/index'
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    registrations: 'users/registrations'
  }
  devise_scope :user do
   # root to: 'users/sessions#home'
    get 'sign_in', to: 'users/sessions#new'
    get '/users/sign_out', to: 'users/sessions#destroy'
  end

  resources :users do
    resources :posts
  end

  resources :posts do
    member do
      get 'show_when_session_destroy'
    end
  end
  root to: 'posts#home'
  get 'home', to: 'posts#home'
end

app/models/post.rb
class Post < ApplicationRecord
  belongs_to :user
  validates :title, presence: true
  validates :content, presence: true
  has_many :pictures, inverse_of: :post, dependent: :destroy
  accepts_nested_attributes_for :pictures, allow_destroy: true
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController

  def new
    @post = current_user.posts.new
    @post.pictures.new
  end

  def create
    @post = current_user.posts.new(post_params)
    return redirect_to root_path if @post.save
    render 'new'
  end

  def index
    @all_posts = Post.all
    @posts = current_user.posts
  end

  def show_when_session_destroy
    @post = Post.find(params[:id])
  end

  def show
    @post = Post.find(params[:id])
  end

  def home
    @posts = Post.all
  end

  def edit
    @post = current_user.posts.find(params[:id])
  end

  def update
    @post = current_user.posts.find(params[:id])
    return redirect_to post_path if @post.update(post_params)
    render 'edit'
  end

  def destroy
    @post = current_user.posts.find(params[:id])
    @post.destroy
    redirect_to root_path
  end

  private

  def post_params
    params.require(:post).permit(:title, :content, :user_id, pictures_attributes: [:id, :post_id, :_destroy, :avatar])
  end
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/posts/_picture_fields.html.erb
<p class="nested-fields">
  <%= f.file_field :avatar %>
  <%= link_to_remove_association 'remove', f %>
</p>

app/views/posts/edit.html.erb
<div class="container">
  <h2>Edit post</h2>

  <%= form_for @post, url: {action: "update"}, html: {class: "nifty_form", multipart: true } do |f| %>
    <table class="table">
      <tr>
        <td><%= f.label :title %></td>
        <td><%= f.text_field :title %></td>
      </tr>
      <tr>
        <td><%= f.label :content %><br />
        <td><%= f.text_area :content %></td>
      </td>
      <%= f.hidden_field :user_id, :value => current_user.id %>
        <tr>
            <td>
            <%= f.fields_for :pictures do |picture| %>
              <%= link_to_add_association 'Add picture', f, :pictures%>
              <%= render "picture_fields", f: picture %>
              </td>
            <% end %>
        </tr>
        <tr>
          <td><%= f.submit "Update"%></td>
        </tr>
    </table>
    <% end %>
</div>

app/views/posts/home.html.erb
<div class="container">
  <% if user_signed_in? %>
    <center>
      <p class="table"><%= image_tag current_user.avatar.url(:medium) %></p><p class="text-info">Name: | <%= current_user.first_name%> <%= current_user.last_name%> |<br/> Contact: | <%= current_user.phone_number%> | </p>
    </center>
  <% else %>
    <div class="container">
      <table class="table">
        <tr>
          <th class="text-info">title</th>
          <th class="text-info">content</th>
          <th class="text-info">pictures</th>
        </tr>
        <% @posts.each do |post| %>
          <tr>
            <td><%= link_to "#{ post.title}", show_when_session_destroy_post_path(post), class:"text-primary" %>
            </td>
            <td class="text-primary"><%= post.content.first(10) %></td>
            <td><%= image_tag(post.pictures.last.avatar.url(:thumb))%></td>
          </tr>
        <% end %>
      </table>
    </div>
  <% end %>
</div>

app/views/posts/index.html.erb
<div class="container">
  <table class="table">
    <tr>
      <th class="text-info">title</th>
      <th class="text-info">content</th>
      <th class="text-info">action</th>
    </tr>
    <% if current_user.has_role? :blogger %>
      <% @posts.each do |post| %>
      <tr>
        <td><%= link_to "#{ post.title}", post_path(post), class:"text-muted" %></td>
         <td class="text-muted"><%= post.content.first(10) %></td>
        <td><%= link_to(image_tag("edit.jpg", :size => "13x16"),  edit_post_path(post)) %> &nbsp  &nbsp <%= link_to(image_tag("delete.jpg", :size => "13x16"),  post_path(post), method: :delete) %></td>
      </tr>
      <% end %>
  <% else %>
    <% @all_posts.each do |post| %>
      <tr>
        <td><%= link_to "#{ post.title}", post_path(post), class:"text-muted" %></td>
         <td class="text-muted"><%= post.content.first(10) %></td>
        <td><%= link_to(image_tag("edit.jpg", :size => "13x16"),  edit_post_path(post)) %> &nbsp  &nbsp <%= link_to(image_tag("delete.jpg", :size => "13x16"),  post_path(post), method: :delete) %></td>
      </tr>
    <% end %>
  <% end %>
    <tr><td><%= link_to 'Back', root_path %></td></tr>
  </table>
</div>

app/views/posts/new.html.erb
<div class="container">
  <h2>Add post</h2>

  <%= form_for @post, url: {action: "create"}, html: {class: "nifty_form", multipart: true } do |f| %>
    <table>
      <tr>
        <td><%= f.label :title %></td></tr>
       <tr> <td><%= f.text_field :title %></td>
      </tr>
      <tr>
        <td><%= f.label :content %></td></tr><div class="fr-view">
        <tr><td><%= f.text_area :content, as: :froala_editor %><div id="example"></div></td></tr></div>

      <%= f.hidden_field :user_id, :value => current_user.id %>
        <tr>
          <td>
            <%= f.fields_for :pictures do |picture| %>
              <%= render "picture_fields", f: picture %>
              <%= link_to_add_association 'Add picture', f, :pictures%>
            <% end %>
          </td>
        </tr>
        <tr>
          <td><%= f.submit "Submit"%></td>
        </tr>
    </table>
    <% end %>
</div>

app/views/posts/show.html.erb
<div class="container">
  <p class="text-info"><%= @post.title %></p>
  <p class="text-info"><%= @post.content %></p>

  <center><p class="text-info">PICTURES</p></center>
  <div class="col">
    <% @post.pictures.each do |picture| %>
      <%= image_tag(picture.avatar.url(:medium))%>
    <% end %>
  </div>
  <tr><td><%= link_to 'Back', user_posts_path(current_user.id) %></td></tr>
</div>

app/views/posts/show_all_posts.html.erb
<div class="container">
  <% if user_signed_in? %>
    <center>
      <p class="table"><%= image_tag current_user.avatar.url(:medium) %></p><p class="text-info">Name: | <%= current_user.first_name%> <%= current_user.last_name%> |<br/> Contact: | <%= current_user.phone_number%> | </p>
    </center>
  <% else %>
    <div class="container">
      <table class="table">
        <tr>
          <th class="text-info">title</th>
          <th class="text-info">content</th>
          <th class="text-info">pictures</th>
        </tr>
        <% @posts.each do |post| %>
          <tr>
            <td class="text-primary"><%= post.title %></td>
            <td class="text-primary"><%= post.content.first(10) %></td>
            <td><%= image_tag(post.pictures.last.avatar.url(:thumb))%></td>
          </tr>
        <% end %>
      </table>
    </div>
  <% end %>
</div>

app/views/posts/show_when_session_destroy.html.erb
<div class="container">
  <p class="text-info"><%= @post.title %></p>
  <p class="text-info"><%= @post.content %></p>

  <center><p class="text-info">PICTURES</p></center>
  <div class="col">
    <% @post.pictures.each do |picture| %>
      <%= image_tag(picture.avatar.url(:medium))%>
    <% end %>

  </div>
  <br />
  <% user = User.find "#{@post.user_id}"%>
    &nbsp<p>&nbsp &nbsp<%= user.first_name %>
    <%= user.last_name %></p>
  <p>&nbsp &nbsp<%= link_to 'Back', root_path %></p>
</div>